//+------------------------------------------------------------------+
//|                                               EA Hedging V01.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum riskrat
  {
   _1,
   _2,
   _3
  };
//--- input parameters
input int      PipsDistanceFromCurrentPrice=5;
input int      TP=20;
input bool     Continue=false;
input double   LotsExponent=2.00;
input double   LotSize=0.10;
input bool     MoneyManagement=false;
input int      StopDoublingLevel=7;
input riskrat  RiskRatio=_3;
input double   LotFactor=0.01;
input double   OptionOfEquity=10;
input int      MagicNumber=12345;
input int      Slippage=1;

// add your account number below i.e: for_account_number 222035, if lefted 0 means no account restriction
#define for_account_number 11242925
// change following expiration date with your own expiration date. date format: YYYY.MM.DD HH:MM
#define expiration_date "2014.12.15 23:00"
int sequences=0;
double point;
bool startasequence=true;
double startequity;
int xcnt=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   point=Point;
   if(Digits%2==1)
     {
      point*=10;
     }
   startequity=AccountEquity();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Comment("");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   int buys=0,sells=0,buystop=0,sellstop=0,cnt=0,total=OrdersTotal();
   double price_buy=0.00,price_sell=0.00,sumlot_buy=0.00;
   double sumlot_sell=0.00,lastlot_buy=0.00,lastlot_sell=0.00;
   double tp_buy=0.00,tp_sell=0.00,firstlot=0.00;
   double lower_limit=startequity-(startequity*OptionOfEquity/100);
   if(OptionOfEquity>0.00 && AccountEquity()<lower_limit)
     {
      for(int x=0;x<total;x++)
        {
         if(OrderSelect(x,SELECT_BY_POS)==true)
           {
            if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
              {
               if(OrderType()==OP_BUY) bool close=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,clrBlue);
               if(OrderType()==OP_SELL) bool close=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,clrRed);
              }
           }
        }
      return;
     }
   double sumprofit=0.00;
   for(int x=0;x<total;x++)
     {
      if(OrderSelect(x,SELECT_BY_POS)==true)
        {
         if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
           {
            if(firstlot==0.00) firstlot=OrderLots();
            int ot=OrderType();
            cnt++;
            sumprofit+=OrderProfit();
            switch(ot)
              {
               case OP_BUY:
                 {
                  buys++;
                  price_buy=OrderOpenPrice();
                  sumlot_buy+=OrderLots();
                  lastlot_buy=OrderLots();
                  tp_buy=OrderTakeProfit();
                  break;
                 }
               case OP_SELL:
                 {
                  sells++;
                  price_sell=OrderOpenPrice();
                  sumlot_sell+=OrderLots();
                  lastlot_sell=OrderLots();
                  tp_sell=OrderTakeProfit();
                  break;
                 }
               case OP_BUYSTOP:
                 {
                  buystop++;
                  sumlot_buy+=OrderLots();
                  price_buy=OrderOpenPrice();
                  tp_buy=OrderTakeProfit();
                  break;
                 }
               case OP_SELLSTOP:
                 {
                  sellstop++;
                  sumlot_sell+=OrderLots();
                  price_sell=OrderOpenPrice();
                  tp_sell=OrderTakeProfit();
                  break;
                 }
              }
           }
        }
     }

   if(cnt!=xcnt)
     {
      total=OrdersTotal();
      for(int x=0;x<total;x++)
        {
         if(OrderSelect(x,SELECT_BY_POS)==true)
           {
            if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
              {
               if(OrderType()==OP_BUY)
                  bool closed=OrderClose(OrderTicket(),OrderLots(),Bid,0);
               if(OrderType()==OP_SELL)
                  bool closed=OrderClose(OrderTicket(),OrderLots(),Ask,0);
               if(OrderType()>OP_SELL)
                  bool deleted=OrderDelete(OrderTicket());
              }
           }
        }
      xcnt=0;
     }
   if(cnt==0 && (Continue==true || sequences==0))
     {
      double lot=GetLot();
      double bs_prc=Ask+PipsDistanceFromCurrentPrice*point;
      double bs_tp=bs_prc+TP*point;
      int ticket1=OrderSend(_Symbol,OP_BUYSTOP,lot,bs_prc,0,0.00,bs_tp,NULL,MagicNumber,0,clrBlue);
      if(ticket1!=-1)
         xcnt++;
      double ss_prc=Bid-PipsDistanceFromCurrentPrice*point;
      double ss_tp=ss_prc-TP*point;
      int ticket2=OrderSend(_Symbol,OP_SELLSTOP,lot,ss_prc,0,0.00,ss_tp,NULL,MagicNumber,0,clrRed);
      if(ticket2!=-1)
         xcnt++;
      sequences++;
     }

   if(cnt==0)
     {
      startasequence=true;
     }

   if(cnt>0 && (cnt<StopDoublingLevel||StopDoublingLevel<=0) && buys==1 && sellstop==1 && startasequence)
     {
      double slot=pow(LotsExponent,cnt-1)*firstlot-sumlot_sell;
      price_sell=MathMin(Bid-PipsDistanceFromCurrentPrice*point,price_sell);
      tp_sell=MathMin(price_sell-TP*point,tp_sell);
      int ticket=OrderSend(_Symbol,OP_SELLSTOP,slot,price_sell,0,0.00,tp_sell,NULL,MagicNumber,0,clrRed);
      if(ticket!=-1)
        {
         startasequence=false;
         xcnt++;
        }
     }

   if(cnt>0 && (cnt<StopDoublingLevel||StopDoublingLevel<=0) && sells==1 && buystop==1 && startasequence)
     {
      double slot=pow(LotsExponent,cnt-1)*firstlot-sumlot_buy;
      price_buy=MathMax(Ask+PipsDistanceFromCurrentPrice*point,price_buy);
      tp_buy=MathMax(price_buy+TP*point,tp_buy);
      int ticket=OrderSend(_Symbol,OP_BUYSTOP,slot,price_buy,0,0.00,tp_buy,NULL,MagicNumber,0,clrBlue);
      if(ticket!=-1)
        {
         startasequence=false;
         xcnt++;
        }
     }

   if(cnt>0 && (cnt<StopDoublingLevel||StopDoublingLevel<=0) && buys>1 && sellstop==0 && !startasequence)
     {
      double slot=pow(LotsExponent,cnt-1)*firstlot-sumlot_sell;
      price_sell=MathMin(Bid-PipsDistanceFromCurrentPrice*point,price_sell);
      tp_sell=MathMin(price_sell-TP*point,tp_sell);
      int ticket=OrderSend(_Symbol,OP_SELLSTOP,slot,price_sell,0,0.00,tp_sell,NULL,MagicNumber,0,clrRed);
      if(ticket!=-1)
         xcnt++;
     }

   if(cnt>0 && (cnt<StopDoublingLevel||StopDoublingLevel<=0) && sells>1 && buystop==0 && !startasequence)
     {
      double slot=pow(LotsExponent,cnt-1)*firstlot-sumlot_buy;
      price_buy=MathMax(Ask+PipsDistanceFromCurrentPrice*point,price_buy);
      tp_buy=MathMax(price_buy+TP*point,tp_buy);
      int ticket=OrderSend(_Symbol,OP_BUYSTOP,slot,price_buy,0,0.00,tp_buy,NULL,MagicNumber,0,clrBlue);
      if(ticket!=-1)
         xcnt++;
     }

   if(cnt==StopDoublingLevel && StopDoublingLevel>0 && buys>sells && sellstop==0)
     {
      total=OrdersTotal();
      for(int x=0;x<total;x++)
        {
         if(OrderSelect(x,SELECT_BY_POS)==true)
           {
            if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
              {
               if(OrderType()==OP_BUY && OrderStopLoss()!=price_sell)
                 {
                  bool mod=OrderModify(OrderTicket(),OrderOpenPrice(),price_sell,OrderTakeProfit(),0);
                 }
               if(OrderType()==OP_SELL && OrderTakeProfit()!=price_sell)
                 {
                  bool mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),price_sell,0);
                 }
              }
           }
        }
     }

   if(cnt==StopDoublingLevel && StopDoublingLevel>0 && buys<sells && buystop==0)
     {
      total=OrdersTotal();
      for(int x=0;x<total;x++)
        {
         if(OrderSelect(x,SELECT_BY_POS)==true)
           {
            if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
              {
               if(OrderType()==OP_BUY && OrderTakeProfit()!=price_buy)
                 {
                  bool mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),price_buy,0);
                 }
               if(OrderType()==OP_SELL && OrderStopLoss()!=price_buy)
                 {
                  bool mod=OrderModify(OrderTicket(),OrderOpenPrice(),price_buy,OrderTakeProfit(),0);
                 }
              }
           }
        }
     }
   string n="\n";
   string p="+ - - - - - ";
   string text=n+p+WindowExpertName();
          text=text+n+p+"Buys: "+its(buys);
          text=text+n+p+"Sells: "+its(sells);
          text=text+n+p+"Buystops: "+its(buystop);
          text=text+n+p+"Sellstops: "+its(sellstop);
          text=text+n+p+"Stop doubling level: "+its(StopDoublingLevel);
          text=text+n+p+"Continue: "+bts(Continue);
          text=text+n+p+"Floating: "+dts(sumprofit,2);
          text=text+n+p+"Equity limit -"+dts(OptionOfEquity,2)+"%: "+dts(lower_limit,2);
          text=text+n+p+"Current equity: "+dts(AccountEquity(),2);
   Comment(text);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetLot()
  {
   double minlot=MarketInfo(_Symbol,MODE_MINLOT);
   double maxlot=MarketInfo(_Symbol,MODE_MAXLOT);
   double lotstep=MarketInfo(_Symbol,MODE_LOTSTEP);
   int decimal=1;
   if(lotstep<0.10)
      decimal=2;
   double lot=LotSize;
   double step=0.00;
   if(RiskRatio==_1)
      step=MathMax(1.00,floor(AccountBalance()/1500));
   if(RiskRatio==_2)
      step=MathMax(1.00,floor(AccountBalance()/1000));
   if(RiskRatio==_3)
      step=MathMax(1.00,floor(AccountBalance()/500));
   if(MoneyManagement)
      lot=MathMax(minlot,MathMin(maxlot,NormalizeDouble(step*LotFactor,decimal)));
   return(lot);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ishittp()
  {
   bool result=false;
   for(int x=OrdersHistoryTotal()-1;x>=0;x--)
     {
      if(OrderSelect(x,SELECT_BY_POS)==true)
        {
         if(OrderSymbol()==_Symbol && OrderMagicNumber()==MagicNumber)
           {
            if(OrderCloseTime()>=Time[0] && OrderClosePrice()==OrderTakeProfit())
              {
               result=true;
               break;
              }
           }
        }
     }
   return(result);
  }
string its(int x){
  return(IntegerToString(x));
}
string dts(double x,int y){
  return(DoubleToStr(x,y));
}
string bts(bool x){
  string x1="true";
  if(x==false)
    x1="false";
  return(x1);
}
